SystemOrganization addCategory: #'BlackGold-Core'!

ALApplication subclass: #BGWikiApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackGold-Core'!

!BGWikiApplication methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 14:47'!
initializeLocator
	locator 
		at: ALPath root 
		put: BGHomePage new asResource! !

Object subclass: #BGComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackGold-Core'!

!BGComponent methodsFor: 'converting' stamp: 'chc 4/18/2017 14:58'!
asResource
	^ ALHtmlResource component: self! !

!BGComponent methodsFor: 'rendering' stamp: 'chc 4/18/2017 14:58'!
renderOn: html
	html h1: self title.
	self renderContentOn: html! !

!BGComponent methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 14:58'!
renderStyleOn: html
	"This is the style sheet used by the various counter examples. 
	Override if necessary for other types of examples."

	^ html style: '
.example {font-size: 48px;}
.counter {margin: 0 1ex;}
a.action {
  font-size: 48px;
  display: inline-block;
  text-decoration: none;
'! !

!BGComponent methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 14:58'!
title
	| in out |
	out := String new writing.
	in := self class name reading.
	in ++ 2.
	in do: 
		[:ch | 
		ch isUppercase ifTrue: [out space].
		out put: ch].
	^ out conclusion	! !

BGComponent subclass: #BGMezzanine
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackGold-Core'!

BGMezzanine subclass: #BGCounter
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackGold-Core'!

!BGCounter methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 14:55'!
initialize
	super initialize.
	count := 0! !

!BGCounter methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 14:55'!
renderContentOn: html
	html a 
		class: 'action';
		navigate: [count := count - 1]; 
		with: '--'.
	html span
		class: 'counter';
		with: count asString.
	html a 
		class: 'action';
		navigate: [count := count + 1]; 
		with: '++'.! !

!BGMezzanine methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 14:59'!
renderContentOn: html
	html a
		id: 'dec';
		class: 'action';
		href: 'javascript:void(0)';
		with: '--'.
	html span
		class: 'counter';
		id: 'count';
		with: '0'.
	html a
		id: 'inc';
		class: 'action';
		href: 'javascript:void(0)';
		with: '++'.
	self renderScriptsOn: html! !

Object subclass: #BGHomePage
	instanceVariableNames: 'examples current'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackGold-Core'!

!BGHomePage methodsFor: 'converting' stamp: 'chc 4/18/2017 14:43'!
asResource
	^ ALExampleResource component: self! !

!BGHomePage methodsFor: 'initialize-release' stamp: 'chc 4/18/2017 14:53'!
initialize
	examples := {
		'counter' -> ALCounterExample.
	}.
	current := examples first value new.! !

!BGHomePage methodsFor: 'rendering' stamp: 'chc 4/18/2017 14:51'!
renderBodyOn: html
	html div
		with: [current renderOn: html]! !

!BGHomePage methodsFor: 'rendering' stamp: 'chc 4/18/2017 14:44'!
renderHtmlOn: html
	html html: 
		[html head: 
			[html title: 'BlackGold'].
		html body: [ self renderBodyOn: html ] ]! !

ALComponentResource subclass: #BGHtmlResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackGold-Core'!

!BGHtmlResource methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 14:49'!
handleGet: aRequest locator: aLocator
	| response |
	response := self respondHtmlLocator: aLocator.
	response vary: (ALStrings with: 'Accept').
	^ response! !

!BGHtmlResource methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 14:48'!
respondHtmlLocator: aLocator
	 ^ ALResponse 
		type: ALContentType html 
		callback: 
			[:out || context |
			context := ALRenderingContext resource: self locator: aLocator.
			component renderHtmlOn: (ALAppHtml5Canvas context: context stream: out)]! !
